#include "PahoLogger.h"

namespace Example {

const Example::Logger::LoggerLevel PahoLogger::DEFAULT_LOGGER_LEVEL = Example::Logger::FATAL;
PahoLogger::PahoLogger() :
    m_Logger("PahoLibrary", DEFAULT_LOGGER_LEVEL) {
    Messenger::MQTTLogger::GetInstance().SetListener(this);
}

PahoLogger::~PahoLogger() {
    Messenger::MQTTLogger::GetInstance().SetListener(NULL);
}

void PahoLogger::OnTrace(const std::string &_msg) {
    // std::cout << _msg << std::endl;
    m_Logger.Trace(_msg);
}

void PahoLogger::OnDebug(const std::string &_msg) {
    // std::cout << _msg << std::endl;
    m_Logger.Debug(_msg);
}

void PahoLogger::OnInfo(const std::string &_msg) {
    // std::cout << _msg << std::endl;
    m_Logger.Info(_msg);
}

void PahoLogger::OnWarn(const std::string &_msg) {
    // std::cout << _msg << std::endl;
    m_Logger.Warn(_msg);
}

void PahoLogger::OnError(const std::string &_msg) {
    // std::cout << _msg << std::endl;
    m_Logger.Error(_msg);
}

void PahoLogger::OnFatal(const std::string &_msg) {
    // std::cout << _msg << std::endl;
    m_Logger.Fatal(_msg);
}

}
