/****************************************************************************
 *  Copyright (c) 2018 Oblo Living d.o.o
 *
 *  All Rights Reserved
 *
 *  P R O P R I E T A R Y    &    C O N F I D E N T I A L
 *
 *  -----------------------------------------------------
 *  http://www.obloliving.com/
 *  -----------------------------------------------------
 *
 * \project Oblo WISE SDK - SDK library
 * \file StrServiceTable.h
 * \brief
 * String service table.
 *
 * @Author Igor Stefanovic
 *
 * \notes
 *
 * \history
 *****************************************************************************/
#ifndef STR_SERVICE_TABLE_H
#define STR_SERVICE_TABLE_H

#include "util/Common.h"

const std::string SERVICE_TYPE_ALARM = "alarm";
const std::string SERVICE_TYPE_BATTERY = "battery";
const std::string SERVICE_TYPE_COLOR = "color";
const std::string SERVICE_TYPE_COLOR_TEMPERATURE = "colorTemperature";
const std::string SERVICE_TYPE_CONTACT = "contact";
const std::string SERVICE_TYPE_DEVICE = "device";
const std::string SERVICE_TYPE_DIAGNOSTIC = "diagnostic";
const std::string SERVICE_TYPE_DIM = "dim";
const std::string SERVICE_TYPE_FLOOD = "flood";
const std::string SERVICE_TYPE_GAS = "gas";
const std::string SERVICE_TYPE_HUMIDITY = "humidity";
const std::string SERVICE_TYPE_LEVEL_CONTROL = "levelControl";
const std::string SERVICE_TYPE_LIGHT = "light";
const std::string SERVICE_TYPE_MOTION = "motion";
const std::string SERVICE_TYPE_POWER_METERING = "powerMetering";
const std::string SERVICE_TYPE_SIMPLE_ALERT = "simpleAlert";
const std::string SERVICE_TYPE_SHUTTER = "shutter";
const std::string SERVICE_TYPE_SMOKE = "smoke";
const std::string SERVICE_TYPE_SWITCH = "switch";
const std::string SERVICE_TYPE_TEMPERATURE = "temperature";
const std::string SERVICE_TYPE_THERMOSTAT = "thermostat";
const std::string SERVICE_TYPE_VOLUME = "volume";
const std::string SERVICE_TYPE_SYSTEM_MONITOR = "systemMonitor";
const std::string SERVICE_TYPE_VM_CONTROL = "vmControl";
const std::string SERVICE_TYPE_BASIC = "basic";
const std::string SERVICE_TYPE_CONFIGURATION = "configuration";

const std::string PROPERTY_NAME_LEVEL = "level";
const std::string PROPERTY_NAME_CRITICAL = "critical";
const std::string PROPERTY_NAME_VOLTAGE = "voltage";
const std::string PROPERTY_NAME_STATE = "state";
const std::string PROPERTY_NAME_VALUE = "value";
const std::string PROPERTY_NAME_MIN = "min";
const std::string PROPERTY_NAME_MAX = "max";
const std::string PROPERTY_NAME_POWER_CONSUMPTION = "powerConsumption";
const std::string PROPERTY_NAME_ACTIVE_POWER = "activePower";
const std::string PROPERTY_NAME_REACTIVE_POWER = "reactivePower";
const std::string PROPERTY_NAME_POWER_FACTOR = "powerFactor";
const std::string PROPERTY_NAME_RMS_CURRENT = "rmsCurrent";
const std::string PROPERTY_NAME_APPARENT_POWER = "apparentPower";
const std::string PROPERTY_NAME_CALIBRATE = "calibrate";
const std::string PROPERTY_NAME_DEFAULT_LEVEL = "defaultLevel";
const std::string PROPERTY_NAME_ANGLE = "angle";
const std::string PROPERTY_NAME_COLOR = "color";
const std::string PROPERTY_NAME_COLOR_TEMPERATURE = "colorTemperature";
const std::string PROPERTY_NAME_DEBOUNCING_PERIOD = "debouncingPeriod";
const std::string PROPERTY_NAME_UP_TIME = "uptime";
const std::string PROPERTY_NAME_BOOT_COUNT = "bootCount";
const std::string PROPERTY_NAME_RSSI = "rssi";
const std::string PROPERTY_NAME_TYPE = "type";
const std::string PROPERTY_NAME_CONNECTION_TYPE = "connectionType";
const std::string PROPERTY_NAME_SLEEPING_TIMEOUT = "sleepingTimeout";
const std::string PROPERTY_NAME_PROTOCOL = "protocol";
const std::string PROPERTY_NAME_NAME = "name";
const std::string PROPERTY_NAME_VERSION = "version";
const std::string PROPERTY_NAME_VERSION_NUMBER = "versionNumber";
const std::string PROPERTY_NAME_SETPOINT = "setpoint";
const std::string PROPERTY_NAME_MODE = "mode";
const std::string PROPERTY_NAME_OPERATION = "operation";
const std::string PROPERTY_NAME_ALERT = "alert";
const std::string PROPERTY_NAME_CPU_LOAD = "cpuLoad";
const std::string PROPERTY_NAME_RAM_LOAD = "ramLoad";
const std::string PROPERTY_NAME_MEMORY_LOAD = "memoryLoad";
const std::string PROPERTY_NAME_COMMAND = "command";
const std::string PROPERTY_NAME_MESSAGE = "message";
const std::string PROPERTY_NAME_SET = "set";
const std::string PROPERTY_NAME_GET = "get";

const std::string COMMAND_NAME_TOGGLE = "toggle";
const std::string COMMAND_NAME_MOVE_TO = "moveTo";
const std::string COMMAND_NAME_STOP = "stop";
const std::string COMMAND_NAME_MOVE_TO_DEFAULT = "moveToDefault";
const std::string COMMAND_NAME_PROXY_CMD = "proxyCmd";
const std::string COMMAND_NAME_SET_CONFIG_PARAM = "setConfigurationParam";
const std::string COMMAND_NAME_GET_CONFIG_PARAM = "getConfigurationParam";

const std::string COMMAND_PARAM_ANY = "any"; // Dummy name for input param
const std::string COMMAND_PARAM_CMD_NAME = "cmdName";
const std::string COMMAND_PARAM_NAME_TRANSITION_TIME = "transitionTime";
#endif //STR_SERVICE_TABLE
