/****************************************************************************
 *  Copyright (c) 2018 Oblo Living d.o.o
 *
 *  All Rights Reserved
 *
 *  P R O P R I E T A R Y    &    C O N F I D E N T I A L
 *
 *  -----------------------------------------------------
 *  http://www.obloliving.com/
 *  -----------------------------------------------------
 *
 * \project Oblo WISE SDK - SDK library
 * \file Network.h
 * \brief
 * Network management class.
 *
 * @Author Igor Stefanovic
 *
 * \notes
 *
 * \history
 *****************************************************************************/
#ifndef NETWORK_H
#define NETWORK_H

#include "util/Common.h"
#include "util/Timer.h"
#include "util/Mutex.h"
#include "util/Exceptions.h"
#include "util/SynchronizedObject.h"
#include "util/Logger.h"

/**
 * @namespace Messenger
 * @brief Implementation of MQTT Client.
 */
namespace Messenger {

/**
 * @interface IConnectionListener
 * @brief Listener on a connection status.
 */
class IConnectionListener {
public:
    /**
     * @fn virtual void OnConnectionLost(const std::string& _cause) = 0;
     * @brief Callback method which is called when a connection is lost.
     * @param _cause Connection lost cause.
     */
    virtual void OnConnectionLost(const std::string& _cause) = 0;
};

}


#endif // NETWORK_H
