/****************************************************************************
 *  Copyright (c) 2018 Oblo Living d.o.o
 *
 *  All Rights Reserved
 *
 *  P R O P R I E T A R Y    &    C O N F I D E N T I A L
 *
 *  -----------------------------------------------------
 *  http://www.obloliving.com/
 *  -----------------------------------------------------
 *
 * \project Oblo WISE SDK - SDK library
 * \file ErrorCodes.h
 * \brief
 * Error codes defines.
 *
 * @Author Igor Stefanovic
 *
 * \notes
 *
 * \history
 *****************************************************************************/
#ifndef ERROR_CODES_H
#define ERROR_CODES_H

/* WISE Error codes */

#define WISE_OK 0
#define WISE_ERROR 10
#define WISE_PROTOCOL_ERROR 11
#define WISE_ILLEGAL_STATE 12
#define WISE_RUNTIME_ERROR 13
#define WISE_TIMEOUT 14
#define WISE_NOT_FOUND 20
#define WISE_ARGUMENT_NOT_FOUND 21
#define WISE_DEVICE_NOT_FOUND 22
#define WISE_NOT_SUPPORTED 30
#define WISE_DEVICE_NOT_SUPPORTED 31
#define WISE_REQUEST_NOT_SUPPORTED 32
#define WISE_COMMAND_NOT_SUPPORTED 33
#define WISE_SERVICE_NOT_SUPPORTED 34
#define WISE_PROPERTY_NOT_SUPPORTED 35
#define WISE_VERSION_NOT_SUPPORTED 36
#define WISE_INVALID_DATA 40
#define WISE_INVALID_ARGUMENT 41
#define WISE_INVALID_FORMAT 42
#define WISE_INVALID_VALUE 43
#define WISE_INVALID_RANGE 44
#define WISE_INVALID_OPTION 45
#define WISE_ACCESS_VIOLATION 50
#define WISE_NOT_AUTHORIZED 51

/* Intern Error codes */

#define INTERN_EXCLUDED -10

/* MQTT Error codes */

#define MQTT_NOT_AUTHORIZED 5


#endif // ERROR_CODES_H
