/****************************************************************************
 *  Copyright (c) 2019 Oblo Living d.o.o
 *
 *  All Rights Reserved
 *
 *  P R O P R I E T A R Y    &    C O N F I D E N T I A L
 *
 *  -----------------------------------------------------
 *  http://www.obloliving.com/
 *  -----------------------------------------------------
 *
 * \project Oblo WISE SDK - SDK library
 * \file Regex.h
 * \brief
 * Regex util class.
 *
 * @Author Igor Stefanovic
 *
 * \notes
 *
 * \history
 *****************************************************************************/
#ifndef REGEX_H
#define REGEX_H
#include <string>
#include <sstream>
#include <cstring>
#include <iostream>
#include <list>
#include <map>
#include <vector>
#include <queue>
#include <unistd.h>
#include <stdio.h>
#include <stdlib.h>
#include <regex.h>

namespace Utility {

class Regex {
public:
    Regex(const std::string& _reg);
    ~Regex();
    static bool Match(const std::string& _match, Regex& _obj);
private:
    regex_t m_RegexObj;
};

}

#endif // REGEX_H
