#include "ssdp/Discovery.h"

using namespace SSDP;
using namespace Utility;

int Discovery::DEFAULT_MSEARCH_INTERVAL = 5000;

Discovery::Discovery() : m_SSDPClient(DEFAULT_MSEARCH_INTERVAL) {
}

Discovery::~Discovery() {
}

void Discovery::StartSearch() {
    m_SSDPClient.StartSSDP(SSDPClient::SEARCH, "");
}

void Discovery::StartListen(const std::string &_hubId) {
    m_SSDPClient.StartSSDP(SSDPClient::LISTEN, _hubId);
}

void Discovery::Stop() {
    m_SSDPClient.StopSSDP();
}

void Discovery::SetSearchInterval(long _searchInterval) {
    m_SSDPClient.SetSearchInterval(_searchInterval);
}

void Discovery::RegisterListener(ISearchListener *_listener) {
    m_SSDPClient.RegisterListener(_listener);
}

void Discovery::UnregisterListener() {
    m_SSDPClient.UnregisterListener();
}

void Discovery::RegisterLogListener(ILogListener* _logListener) {
    m_SSDPClient.RegisterLogListener(_logListener);
}

void Discovery::UnregisterLogListener() {
    m_SSDPClient.UnregisterLogListener();
}
