#include "ssdp/SocketAddress.h"

using namespace SSDP;

SocketAddress::SocketAddress() {
    std::memset(&m_SocketAddress, 0, sizeof(m_SocketAddress));
    m_SocketAddress.sin_family = AF_INET;
}

SocketAddress::SocketAddress(const sockaddr_in *_sockAddr) {
    std::memcpy(&m_SocketAddress, _sockAddr, sizeof(m_SocketAddress));
}

SocketAddress::SocketAddress(const std::string &_addr, unsigned int _port) {
    std::memset(&m_SocketAddress, 0, sizeof(m_SocketAddress));
    m_SocketAddress.sin_family = AF_INET;
    m_SocketAddress.sin_port = htons(_port);
    if (_addr.empty()) {
        m_SocketAddress.sin_addr.s_addr = htonl(INADDR_ANY);
    } else {
        m_SocketAddress.sin_addr.s_addr = inet_addr(_addr.c_str());
    }
}

struct sockaddr* SocketAddress::GetSocketAddress() const {
    return (struct sockaddr*) &m_SocketAddress;
}

in_port_t SocketAddress::GetPort() const {
    return m_SocketAddress.sin_port;
}

struct in_addr SocketAddress::GetAddress() const {
    return m_SocketAddress.sin_addr;
}

unsigned int SocketAddress::GetSize() const {
    return sizeof(m_SocketAddress);
}
