#include "util/Exceptions.h"

using namespace Utility;

BaseException::BaseException(const std::string &_msg, int _code) :
    m_Name(BASE_EXCEPTION),
    m_Message(_msg),
    m_Code(_code) {

}

BaseException::BaseException(const std::string _name, const std::string& _msg, int _code) :
    m_Name(_name),
    m_Message(_msg),
    m_Code(_code) {

}

BaseException::BaseException(const BaseException &_baseException) :
    m_Name(_baseException.m_Name),
    m_Message(_baseException.m_Message),
    m_Code(_baseException.m_Code) {

}

BaseException::~BaseException() throw() {

}

const char* BaseException::what() const throw () {
    return m_Name.c_str();
}

std::string BaseException::GetName() const {
    return m_Name;
}

std::string BaseException::GetMessage() const {
    return m_Message;
}

int BaseException::GetCode() const {
    return m_Code;
}

void BaseException::SetMessage(const std::string &_message) {
    m_Message = _message;
}

void BaseException::SetCode(int _code) {
    m_Code = _code;
}

void BaseException::Rethrow() const {
    throw *this;
}

const std::string BaseException::BASE_EXCEPTION = "BaseException";
const std::string ProtocolException::PROTOCOL_EXCEPTION = "ProtocolException";
const std::string ParseException::PARSE_EXCEPTION = "ParseException";
const std::string TimeoutException::TIMEOUT_EXCEPTION = "TimeoutException";
const std::string NullPointerException::NULLPOINTER_EXCEPTION = "NullPointerException";
const std::string InvalidArgumentException::INVALID_ARGUMENT_EXCEPTION = "InvalidArgumentException";
const std::string InvalidStateException::INVALID_STATE_EXCEPTION = "InvalidStateException";
const std::string RuntimeException::RUNTIME_EXCEPTION = "RuntimeException";
const std::string NotFoundException::NOTFOUND_EXCEPTION = "NotFoundException";
