#include "util/JsonStruct.h"

using namespace Utility;

JsonStruct::JsonStruct() {
    m_Node = Jzon::object();
}

JsonStruct::JsonStruct(const JsonStruct &_jsonStruct) : m_Node(_jsonStruct.m_Node) {

}

JsonStruct::JsonStruct(const std::string &_json) {
    Parse(_json);
}

JsonStruct::JsonStruct(const Jzon::Node& _jzonNode) : m_Node(_jzonNode) {

}

JsonStruct::~JsonStruct() {
}

void JsonStruct::Insert(const std::string &_key, const JsonStruct& _json) {
    m_Node.add(_key, _json.GetNode());
}

JsonStruct::Ptr JsonStruct::ExtractJson(const std::string& _key) {
    JsonStruct::Ptr pTemp = new JsonStruct();
    pTemp->m_Node = m_Node.get(_key);
    return pTemp;
}

Jzon::Node JsonStruct::Extract(const std::string& _key) const {
    Jzon::Node node = m_Node.get(_key);
    return node;
}

std::vector<Jzon::Node> JsonStruct::ExtractArray(const std::string &_key) const {
    Jzon::Node array;
    array = m_Node.get(_key);
    Jzon::Node::iterator itr = array.begin();
    std::vector<Jzon::Node> vector;
    for (; itr != array.end(); ++itr) {
        vector.push_back(itr->second);
    }

    return vector;
}

bool JsonStruct::IsEmpty() const {
    return m_Node.getCount() == 0;
}

void JsonStruct::Parse(const std::string &_json) {
    Jzon::Parser parser;
    m_Node = parser.parseString(_json);
}

Jzon::Node JsonStruct::GetNode() const {
    return m_Node;
}

std::string JsonStruct::ToString() const {
    Jzon::Writer writer;
    std::string temp;
    writer.writeString(m_Node, temp);

    return temp;
}
