#include "util/Logger.h"

using namespace Utility;

Logger::Logger() :
    m_LogListener(NULL) {
}

void Logger::RegisterLogListener(ILogListener *_logListener) {
    if (m_LogListener == NULL) {
        m_LogListener = _logListener;
    }
}

void Logger::UnregisterLogListener() {
    if (m_LogListener != NULL) {
        m_LogListener = NULL;
    }
}

void Logger::OnTrace(const std::string &_msg) {
    if (m_LogListener != NULL) {
        m_LogListener->OnTrace(_msg);
    }
}

void Logger::OnDebug(const std::string &_msg) {
    if (m_LogListener != NULL) {
        m_LogListener->OnDebug(_msg);
    }
}

void Logger::OnInfo(const std::string &_msg) {
    if (m_LogListener != NULL) {
        m_LogListener->OnInfo(_msg);
    }
}

void Logger::OnWarn(const std::string &_msg) {
    if (m_LogListener != NULL) {
        m_LogListener->OnWarn(_msg);
    }
}

void Logger::OnError(const std::string &_msg) {
    if (m_LogListener != NULL) {
        m_LogListener->OnError(_msg);
    }
}

void Logger::OnFatal(const std::string &_msg) {
    if (m_LogListener != NULL) {
        m_LogListener->OnFatal(_msg);
    }
}
