#include "util/SynchronizedObject.h"

using namespace Utility;

void SynchronizedObject::Lock() {
    m_Mutex.Lock();
}

bool SynchronizedObject::TryLock() {
    return m_Mutex.TryLock();
}

void SynchronizedObject::Unlock() {
    m_Mutex.Unlock();
}

void SynchronizedObject::Notify() {
    m_Event.Set();
}

void SynchronizedObject::Wait() {
    m_Event.Reset();
    m_Event.Wait();
}

void SynchronizedObject::Wait(long milliseconds) {
    m_Event.Reset();
    m_Event.Wait(milliseconds);
}

bool SynchronizedObject::TryWait(long milliseconds) {
    m_Event.Reset();
    return m_Event.Wait(milliseconds);
}

