#include "util/Thread.h"
#include <errno.h>

using namespace Utility;

void RunnableHolder::Run() {
    m_Target.Run();
}

Thread::Thread() : m_TID(0), m_Runnable(NULL), m_Terminated(true) {

}

Thread::~Thread() {
    Join();
}

void Thread::Start(Runnable& _runnable) {
    m_Terminated = false;
    m_Runnable = new RunnableHolder(_runnable);
    CreateThread();
}

void Thread::Join() {
    if (!m_Terminated) {
        int rc = pthread_join(m_TID, NULL);
        if (rc != 0) {
            std::cout << "Failed to join Thread " << rc << std::endl;
        }
        m_Terminated = true;
    }
}

pthread_t Thread::GetID() const {
    return m_TID;
}

void Thread::CreateThread() {
    int rc = pthread_create(&m_TID, NULL, &ThreadFunction, static_cast<void*>(this));
    if (rc != 0) {
        std::cout << "Failed to create Thread" << std::endl;
    }
}

void* Thread::ThreadFunction(void* ptr) {
    Thread* thread = static_cast<Thread*>(ptr);
    thread->m_Runnable->Run();
    pthread_exit(NULL);
}
